/*
 * Secret Labs' Regular Expression Engine
 *
 * regular expression matching engine
 *
 * Copyright (c) 1997-2001 by Secret Labs AB.  All rights reserved.
 *
 * NOTE: This file is generated by regex.py.  If you need
 * to change anything in here, edit regex.py and run it.
 *
 * 2009-07-26 mrab Re-written
 */

#define RE_MAGIC 20090726

/* Size of a code word (must be unsigned short or larger, and
   large enough to hold a Py_UNICODE character). */

#define RE_CODE Py_UCS4
#define RE_UNLIMITED 0xFFFFFFFF

#define RE_OP_FAILURE 0
#define RE_OP_SUCCESS 1
#define RE_OP_ANY 2
#define RE_OP_ANY_ALL 3
#define RE_OP_ANY_ALL_REV 4
#define RE_OP_ANY_REV 5
#define RE_OP_ATOMIC 6
#define RE_OP_BEGIN_GROUP 7
#define RE_OP_BOUNDARY 8
#define RE_OP_BRANCH 9
#define RE_OP_CATEGORY 10
#define RE_OP_CATEGORY_REV 11
#define RE_OP_CHARACTER 12
#define RE_OP_CHARACTER_IGNORE 13
#define RE_OP_CHARACTER_IGNORE_REV 14
#define RE_OP_CHARACTER_REV 15
#define RE_OP_END 16
#define RE_OP_END_GROUP 17
#define RE_OP_END_OF_LINE 18
#define RE_OP_END_OF_STRING 19
#define RE_OP_END_OF_STRING_LINE 20
#define RE_OP_GREEDY_REPEAT 21
#define RE_OP_GROUP 22
#define RE_OP_GROUP_EXISTS 23
#define RE_OP_LAZY_REPEAT 24
#define RE_OP_LOOKAROUND 25
#define RE_OP_NEXT 26
#define RE_OP_RANGE 27
#define RE_OP_REF_GROUP 28
#define RE_OP_REF_GROUP_IGNORE 29
#define RE_OP_REF_GROUP_IGNORE_REV 30
#define RE_OP_REF_GROUP_REV 31
#define RE_OP_SET 32
#define RE_OP_SET_IGNORE 33
#define RE_OP_SET_IGNORE_REV 34
#define RE_OP_SET_REV 35
#define RE_OP_START_OF_LINE 36
#define RE_OP_START_OF_STRING 37
#define RE_OP_UNLIMITED_GREEDY_REPEAT 38
#define RE_OP_UNLIMITED_LAZY_REPEAT 39

char* re_op_text[] = {
    "RE_OP_FAILURE",
    "RE_OP_SUCCESS",
    "RE_OP_ANY",
    "RE_OP_ANY_ALL",
    "RE_OP_ANY_ALL_REV",
    "RE_OP_ANY_REV",
    "RE_OP_ATOMIC",
    "RE_OP_BEGIN_GROUP",
    "RE_OP_BOUNDARY",
    "RE_OP_BRANCH",
    "RE_OP_CATEGORY",
    "RE_OP_CATEGORY_REV",
    "RE_OP_CHARACTER",
    "RE_OP_CHARACTER_IGNORE",
    "RE_OP_CHARACTER_IGNORE_REV",
    "RE_OP_CHARACTER_REV",
    "RE_OP_END",
    "RE_OP_END_GROUP",
    "RE_OP_END_OF_LINE",
    "RE_OP_END_OF_STRING",
    "RE_OP_END_OF_STRING_LINE",
    "RE_OP_GREEDY_REPEAT",
    "RE_OP_GROUP",
    "RE_OP_GROUP_EXISTS",
    "RE_OP_LAZY_REPEAT",
    "RE_OP_LOOKAROUND",
    "RE_OP_NEXT",
    "RE_OP_RANGE",
    "RE_OP_REF_GROUP",
    "RE_OP_REF_GROUP_IGNORE",
    "RE_OP_REF_GROUP_IGNORE_REV",
    "RE_OP_REF_GROUP_REV",
    "RE_OP_SET",
    "RE_OP_SET_IGNORE",
    "RE_OP_SET_IGNORE_REV",
    "RE_OP_SET_REV",
    "RE_OP_START_OF_LINE",
    "RE_OP_START_OF_STRING",
    "RE_OP_UNLIMITED_GREEDY_REPEAT",
    "RE_OP_UNLIMITED_LAZY_REPEAT",
};

/* Character categories. */
#define RE_CAT_C 0
#define RE_CAT_CC 1
#define RE_CAT_CF 2
#define RE_CAT_CN 3
#define RE_CAT_CO 4
#define RE_CAT_CS 5
#define RE_CAT_L 6
#define RE_CAT_LL 7
#define RE_CAT_LM 8
#define RE_CAT_LO 9
#define RE_CAT_LT 10
#define RE_CAT_LU 11
#define RE_CAT_M 12
#define RE_CAT_MC 13
#define RE_CAT_ME 14
#define RE_CAT_MN 15
#define RE_CAT_N 16
#define RE_CAT_ND 17
#define RE_CAT_NL 18
#define RE_CAT_NO 19
#define RE_CAT_P 20
#define RE_CAT_PC 21
#define RE_CAT_PD 22
#define RE_CAT_PE 23
#define RE_CAT_PF 24
#define RE_CAT_PI 25
#define RE_CAT_PO 26
#define RE_CAT_PS 27
#define RE_CAT_S 28
#define RE_CAT_SC 29
#define RE_CAT_SK 30
#define RE_CAT_SM 31
#define RE_CAT_SO 32
#define RE_CAT_Z 33
#define RE_CAT_ZL 34
#define RE_CAT_ZP 35
#define RE_CAT_ZS 36
#define RE_CAT_ALNUM 37
#define RE_CAT_ALPHA 38
#define RE_CAT_ASCII 39
#define RE_CAT_BLANK 40
#define RE_CAT_CNTRL 41
#define RE_CAT_DIGIT 42
#define RE_CAT_GRAPH 43
#define RE_CAT_LINEBREAK 44
#define RE_CAT_LOWER 45
#define RE_CAT_PRINT 46
#define RE_CAT_PUNCT 47
#define RE_CAT_SPACE 48
#define RE_CAT_UPPER 49
#define RE_CAT_WORD 50
#define RE_CAT_XDIGIT 51

/* Unicode character properties. */
#define RE_PROP_MASK_C 0x0003E001
#define RE_PROP_MASK_CC 0x00002000
#define RE_PROP_MASK_CF 0x00004000
#define RE_PROP_MASK_CN 0x00020001
#define RE_PROP_MASK_CO 0x00010000
#define RE_PROP_MASK_CS 0x00008000
#define RE_PROP_MASK_L 0x000C000E
#define RE_PROP_MASK_LL 0x00000004
#define RE_PROP_MASK_LM 0x00040000
#define RE_PROP_MASK_LO 0x00080000
#define RE_PROP_MASK_LT 0x00000008
#define RE_PROP_MASK_LU 0x00000002
#define RE_PROP_MASK_M 0x00000070
#define RE_PROP_MASK_MC 0x00000020
#define RE_PROP_MASK_ME 0x00000040
#define RE_PROP_MASK_MN 0x00000010
#define RE_PROP_MASK_N 0x00000380
#define RE_PROP_MASK_ND 0x00000080
#define RE_PROP_MASK_NL 0x00000100
#define RE_PROP_MASK_NO 0x00000200
#define RE_PROP_MASK_P 0x07F00000
#define RE_PROP_MASK_PC 0x00100000
#define RE_PROP_MASK_PD 0x00200000
#define RE_PROP_MASK_PE 0x00800000
#define RE_PROP_MASK_PF 0x02000000
#define RE_PROP_MASK_PI 0x01000000
#define RE_PROP_MASK_PO 0x04000000
#define RE_PROP_MASK_PS 0x00400000
#define RE_PROP_MASK_S 0x78000000
#define RE_PROP_MASK_SC 0x10000000
#define RE_PROP_MASK_SK 0x20000000
#define RE_PROP_MASK_SM 0x08000000
#define RE_PROP_MASK_SO 0x40000000
#define RE_PROP_MASK_Z 0x00001C00
#define RE_PROP_MASK_ZL 0x00000800
#define RE_PROP_MASK_ZP 0x00001000
#define RE_PROP_MASK_ZS 0x00000400

#define RE_PROP_MASK_ALNUM (RE_PROP_MASK_L | RE_PROP_MASK_ND)
#define RE_PROP_MASK_NONGRAPH (RE_PROP_MASK_Z | RE_PROP_MASK_C)
#define RE_PROP_MASK_PUNCT (RE_PROP_MASK_P | RE_PROP_MASK_S)
#define RE_PROP_MASK_WORD (RE_PROP_MASK_L | RE_PROP_MASK_M | RE_PROP_MASK_N | \
  RE_PROP_MASK_PC)

/* ASCII character categories. */
#define RE_MASK_DIGIT 0x1
#define RE_MASK_LOWER 0x2
#define RE_MASK_PUNCT 0x4
#define RE_MASK_SPACE 0x8
#define RE_MASK_UPPER 0x10
#define RE_MASK_XDIGIT 0x20

/* alpha = upper | lower */
#define RE_MASK_ALPHA (RE_MASK_UPPER | RE_MASK_LOWER)
/* alnum = alpha | digit */
#define RE_MASK_ALNUM (RE_MASK_ALPHA | RE_MASK_DIGIT)

char re_ascii_category[128] = {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x21, 0x21, 0x21, 0x21, 0x21, 0x21, 0x21, 0x21,
    0x21, 0x21, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x10,
    0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
    0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
    0x10, 0x10, 0x10, 0x04, 0x04, 0x04, 0x04, 0x04,
    0x04, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02, 0x02,
    0x02, 0x02, 0x02, 0x04, 0x04, 0x04, 0x04, 0x00,
};

#define RE_FLAG_ASCII 0x80
#define RE_FLAG_DOTALL 0x10
#define RE_FLAG_IGNORECASE 0x2
#define RE_FLAG_LOCALE 0x4
#define RE_FLAG_MULTILINE 0x8
#define RE_FLAG_TEMPLATE 0x1
#define RE_FLAG_UNICODE 0x20
#define RE_FLAG_VERBOSE 0x40
#define RE_FLAG_ZEROWIDTH 0x100
